--- Event

class("Event")

require("Asserts")
require("EventListener")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function Event:addListener(listenerFunction)
  Asserts.assertType(listenerFunction, "listenerFunction", "function")
  local listener = EventListener.new(self, listenerFunction)
  table.insert(self.listeners, listener)
  return listener
end

function Event:removeListener(listener)
  TableUtils.removeValueFromArray(self.listeners, listener)
end

function Event:removeAllListeners()
  self.listeners = {}
end

function Event:call(...)
  for _, listener in ipairs(self.listeners) do
    listener:call(...)
  end
end

-- Constructor ------------------------

function Event.new()
  local self = {}
  Mixin.mix(self, Event)
  self.listeners = {}
  return self
end
