--- DropShadowUtils
-- @author Created by anton on October 03, 2022.

class("DropShadowUtils")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- NOTE: Originally, offsets were based on the button's height. However, that
-- breaks the optical effect when different button sizes are present in the
-- screen. The shadow should be proportional to the button's "depth", not its
-- width or height.
local REFERENCE_HEIGHT = ReferenceDevice.getScaledWidth(54.0)

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function DropShadowUtils.getOffsetX()
  return -0.04 * REFERENCE_HEIGHT
end

function DropShadowUtils.getOffsetY()
  return -0.06 * REFERENCE_HEIGHT
end

function DropShadowUtils.offsetDropShadow(dropShadow) 
  dropShadow:offsetX(DropShadowUtils.getOffsetX())
  dropShadow:offsetY(DropShadowUtils.getOffsetY())
end
