--- EndGameScreen

class("EndGameScreen")

require("sphinx.GameResultScreen")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local BACKGROUND_COLOR = {0.08, 0.11, 0.24}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function EndGameScreen:show()
  local duration = 0.2
  local ease = nil
  wait(AHOpacityTo.new(self.background, duration, ease, 1):start())

  self.gameResults:show()
end

function EndGameScreen:moveToNextScreen()
  SphinxSound.playClick()

  wait(self.gameResults:hide())
  GameSession.notifyGameWin()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function EndGameScreen.new(displayName, endTime, gameData, roundsCompleted)
  local self = Group.newFullScreen()
  Mixin.mix(self, EndGameScreen)

  self.background = FilledRectangle.newFullScreen(BACKGROUND_COLOR)
  self.background:setOpacity(0)
  self:insertAtCenter(self.background)

  self.gameResults = GameResultScreen.new(self, displayName, endTime, gameData, roundsCompleted)
  self:insertAtCenter(self.gameResults)

  return self
end
