--- SphinxColors

class("SphinxColors")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local COLOR_TABLE =
{
  primaries = {
    aqua = ColorUtils.colorHex24ToStd(0x07B1C8),          --primaries---aqua: #07B1C8;
    white = ColorUtils.colorHex24ToStd(0xFFFFFF),         --primaries---white: #FFFFFF;
    red = ColorUtils.colorHex24ToStd(0xF44109),           --primaries---red: #F44109;
    yellow = ColorUtils.colorHex24ToStd(0xFFB900),        --primaries---yellow: #FFB900;
    fuchsia = ColorUtils.colorHex24ToStd(0xF6377A),       --primaries---fuchia: #F6377A;
    turtle = ColorUtils.colorHex24ToStd(0x6AB812),        --primaries---turtle: #6AB812;
    red = ColorUtils.colorHex24ToStd(0xF44109),           --primaries---red: #F44109;
    text = ColorUtils.colorHex24ToStd(0xDEE0E8)           --primaries-text: #DEE0E8;
  },
  basic = {
    yellow = ColorUtils.colorHex24ToStd(0xFFD000),        --basic---yellow: #FFD000;
    orange = ColorUtils.colorHex24ToStd(0xFF802B),        --basic---orange: #FF802B;
    red = ColorUtils.colorHex24ToStd(0xFF595A),           --basic---red: #FF595A;
    fuchsia = ColorUtils.colorHex24ToStd(0xF8458D),       --basic---fuchsia: #F8458D;
    pink = ColorUtils.colorHex24ToStd(0xEF58F2),          --basic---pink: #EF58F2;
    turtle = ColorUtils.colorHex24ToStd(0x83D01C),        --basic---turtle: #83D01C;
    green = ColorUtils.colorHex24ToStd(0x25BD6C),         --basic---green: #25BD6C;
    mint = ColorUtils.colorHex24ToStd(0x13B2A9),          --basic---mint: #13B2A9;
    aqua = ColorUtils.colorHex24ToStd(0x17C3DF),          --basic---aqua: #17C3DF;
    purple = ColorUtils.colorHex24ToStd(0x966DEB),        --basic---purple: #966DEB;
    brown = ColorUtils.colorHex24ToStd(0xCC6C4A),         --basic-brown: #CC6C4A;
    peach = ColorUtils.colorHex24ToStd(0xFFC9A6),         --basic---peach: #FFC9A6;
    blue = ColorUtils.colorHex24ToStd(0x4960EC)           --basic-blue: #4960EC;
  },
  mid = {
    purple = ColorUtils.colorHex24ToStd(0x754CDE),        --mid---purple: #754CDE;
    aqua = ColorUtils.colorHex24ToStd(0x1289AB),          --mid---aqua: #1289AB;
    mint = ColorUtils.colorHex24ToStd(0x078277),          --mid---mint: #078277;
    green = ColorUtils.colorHex24ToStd(0x098338),         --mid---green: #098338;
    turtle = ColorUtils.colorHex24ToStd(0x53A109),        --mid---turtle: #53A109;
    pink = ColorUtils.colorHex24ToStd(0xBD2CC0),          --mid---pink: #BD2CC0;
    fuchsia = ColorUtils.colorHex24ToStd(0xC9275B),       --mid---fuchsia: #C9275B;
    red = ColorUtils.colorHex24ToStd(0xCE2B33),           --mid---red: #CE2B33;
    orange = ColorUtils.colorHex24ToStd(0xD94C06),        --mid---orange: #D94C06;
    yellow = ColorUtils.colorHex24ToStd(0xFFA300),        --mid---yellow: #FFA300;
    brown = ColorUtils.colorHex24ToStd(0x864A3C),         --mid-brown: #864A3C;
    peach = ColorUtils.colorHex24ToStd(0xD87751),         --mid-peach: #D87751;
    blue = ColorUtils.colorHex24ToStd(0x322CBC)           --mid-blue: #322CBC;
  },
  dark = {
    yellow = ColorUtils.colorHex24ToStd(0xB66D00),        --dark---yellow: #B66D00;
    orange = ColorUtils.colorHex24ToStd(0x8F3508),        --dark---orange: #8F3508;
    red = ColorUtils.colorHex24ToStd(0x5B1010),           --dark---red: #5B1010;
    fuchsia = ColorUtils.colorHex24ToStd(0x790029),       --dark---fuchsia: #790029;
    pink = ColorUtils.colorHex24ToStd(0x5A105B),          --dark---pink: #5A105B;
    turtle = ColorUtils.colorHex24ToStd(0x235B10),        --dark---turtle: #235B10;
    green = ColorUtils.colorHex24ToStd(0x005F26),         --dark---green: #005F26;
    mint = ColorUtils.colorHex24ToStd(0x08534F),          --dark---mint: #08534F;
    aqua = ColorUtils.colorHex24ToStd(0x0B4254),          --dark---aqua: #0B4254;
    purple = ColorUtils.colorHex24ToStd(0x311474),        --dark---purple: #311474;
    brown = ColorUtils.colorHex24ToStd(0x4F2920),         --dark-brown: #4F2920;
    blue = ColorUtils.colorHex24ToStd(0x1D1C53),          --dark-blue: #1D1C53;
    peach = ColorUtils.colorHex24ToStd(0x7B4C39)          --dark---peach: #7B4C39;
  },
  darker = {
    blue = ColorUtils.colorHex24ToStd(0x0C123C)
  },
  round1 = {
    darkest = ColorUtils.colorHex24ToStd(0x171D41),       --round-1-darkest: #171D41;
    dark = ColorUtils.colorHex24ToStd(0x222A52),          --round-1-dark: #222A52;
    mid = ColorUtils.colorHex24ToStd(0x2B3566),           --round-1---mid: #2B3566;
    light = ColorUtils.colorHex24ToStd(0x59628E),         --round-1---light: #59628E;
    lighter = ColorUtils.colorHex24ToStd(0x767FAD),       --round-1----lighter: #767FAD;
    box = ColorUtils.colorHex24ToStd(0x8484AD),           --round-1-box: #8484AD;
    lightest = ColorUtils.colorHex24ToStd(0xC4CAE9),      --round-1---lightest: #C4CAE9;
    yellow = ColorUtils.colorHex24ToStd(0x5B524E)         --round-1-yellow: #5B524E;
  },
  round2 = {
    darkest = ColorUtils.colorHex24ToStd(0x152A3E),       --round-2-darkest: #152A3E;
    dark = ColorUtils.colorHex24ToStd(0x012A34),          --round-2-dark: #012A34;
    mid = ColorUtils.colorHex24ToStd(0x004858),           --round-2-mid: #004858;
    light = ColorUtils.colorHex24ToStd(0x316D67),         --round-2-light: #316D67;
    lighter = ColorUtils.colorHex24ToStd(0x598E88),       --round-2-lighter: #598E88;
    box = ColorUtils.colorHex24ToStd(0x59A19D),           --round-2-box: #59A19D;
    lightest = ColorUtils.colorHex24ToStd(0x98BDB8)       --round-2-lightest: #98BDB8;
  },
  round3 = {
    darkest = ColorUtils.colorHex24ToStd(0x220F29),       --round-3-darkest: #220F29;
    dark = ColorUtils.colorHex24ToStd(0x301136),          --round-3-dark: #301136;
    mid = ColorUtils.colorHex24ToStd(0x46154A),           --round-3-mid: #46154A;
    light = ColorUtils.colorHex24ToStd(0x724177),         --round-3-light: #724177;
    lighter = ColorUtils.colorHex24ToStd(0x7F5583),       --round-3-lighter: #7F5583;
    box = ColorUtils.colorHex24ToStd(0x926C94),           --round-3-box: #926C94;
    lightest = ColorUtils.colorHex24ToStd(0xB57EBA)       --round-3-lightest: #B57EBA;
  }
}

local SCENE = {
  {
    transitionBackground = COLOR_TABLE["round1"]["dark"],
    gameBackground = COLOR_TABLE["round1"]["mid"],
    button = COLOR_TABLE["round1"]["light"],
    buttonCount = COLOR_TABLE["round1"]["darkest"],
    niceJob = COLOR_TABLE["round1"]["darkest"]
  },
  {
    transitionBackground = COLOR_TABLE["round2"]["dark"],
    gameBackground = COLOR_TABLE["round2"]["mid"],
    button = COLOR_TABLE["round2"]["light"],
    buttonCount = COLOR_TABLE["round2"]["darkest"],
    niceJob = COLOR_TABLE["round2"]["darkest"]
  },
  {
    transitionBackground = COLOR_TABLE["round3"]["dark"],
    gameBackground = COLOR_TABLE["round3"]["mid"],
    button = COLOR_TABLE["round3"]["light"],
    buttonCount = COLOR_TABLE["round3"]["darkest"],
    niceJob = COLOR_TABLE["round3"]["darkest"]
  }
}

SphinxColors.TRANSPARENT = {0,0,0,0}
SphinxColors.WHITE = {1,1,1,1}
SphinxColors.BLACK = {0,0,0,1}
SphinxColors.DROP_SHADOW = {0, 0, 0, 0.25}

SphinxColors.roundIndex = 1
SphinxColors.CURRENT_SCENE = SCENE[1]

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SphinxColors.setRoundIndex(index)
  SphinxColors.CURRENT_SCENE = SCENE[index]
  SphinxColors.roundIndex = index
end

function SphinxColors.get(category, id)
  local color = COLOR_TABLE[category][id]
  assert(color ~= nil, "Invalid category/id "  .. tostring(category) .. " " .. tostring(id))
  return color
end

function SphinxColors.getRoundColor(id)
  local category = "round" .. SphinxColors.roundIndex
  return SphinxColors.get(category, id)
end

function SphinxColors.getFullColorTable()
  return SCENE
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------
