--- RiverBendGame

class("RiverBendGame")

require("sphinx.SphinxGame")
require("sphinx.ScoreTracker")

require("RiverBendRoundManager")
require("RiverBendScene")
require("RiverBendModel")
require("RiverBendInterstitialShapes")
require("RiverBendTutorialCarousel")

-- ----------------------------------------------------------------------------
-- Configuration
-- ------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Protected Sphinx API
-- ----------------------------------------------------------------------------

function RiverBendGame:_createRoundInterstitial()
  local interstitialShapes = RiverBendInterstitialShapes.new()
  local roundInterstitial = RoundTransitionManager.new(interstitialShapes, RiverBendColors.SCENE)
  return roundInterstitial
end

function RiverBendGame:_createModel(roundNumber)
  return RiverBendRoundManager.getRound(roundNumber)
end

function RiverBendGame:_createScene(model, roundNumber, scoreTracker)
  return RiverBendScene.new(self:getWidth(), self:getHeight(), model, roundNumber, scoreTracker)
end

function RiverBendGame:_enableInGameTutorial(scene)
  scene:enableInGameTutorial()
end

function RiverBendGame:_hasTutorialCarousel(roundNumber)
  return RiverBendTutorialCarousel.hasRound(roundNumber)
end

function RiverBendGame:_createTutorialCarousel(roundNumber)
  return RiverBendTutorialCarousel.new(roundNumber)
end

function RiverBendGame:_getMinimumMoveCount(model)
  return model:getClueCount()
end

function RiverBendGame:_getDisplayName()
  return Localizer.get("RIVERBEND_DISPLAY_NAME")
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------
--
local function setThresholdsSoAppWillNotCrash()
  GameSession.setScoreThresholds(0, 0)
end


-- Constructor ------------------------

function RiverBendGame.new()
  local self = SphinxGame.new()
  Mixin.mix(self, RiverBendGame)

  setThresholdsSoAppWillNotCrash()

  return self
end
