--- RiverBendTutorialCarousel

class("RiverBendTutorialCarousel")

require("sphinx.TutorialCarousel")
require("RiverBendColors")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local CARD_DEFINITIONS = {
  {
    {
      image = "riverbend_tutorial_01.png",
      text = "The goal of each puzzle is to fill in the board with completed words."
    },
    {
      image = "riverbend_tutorial_02.png",
      text = "Hold and drag over letters to create words."
    },
    {
      image = "riverbend_tutorial_03.png",
      text = "Each letter can only be used once."
    },
    {
      image = "riverbend_tutorial_04.png",
      text = "Use the arrow buttons to see other clues."
    }
  }
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RiverBendTutorialCarousel.hasRound(roundNumber)
  return roundNumber <= #CARD_DEFINITIONS
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function RiverBendTutorialCarousel.new(roundNumber)
  assert(roundNumber <= #CARD_DEFINITIONS, "No data found for round " .. tostring(roundNumber))

  local carouselData = CARD_DEFINITIONS[roundNumber]
  local backgroundColor = RiverBendColors.SCENE[roundNumber].gameBackground

  local self = TutorialCarousel.new(carouselData, roundNumber, backgroundColor)
  Mixin.mix(self, RiverBendTutorialCarousel)

  return self
end
