--- RiverBendTutorialRounds

class("RiverBendTutorialRounds")

require("RiverBendModel")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local ROUNDS =
{
  {
    board = {
      {
        { letter = "M", clueIndex = 1, answerIndex = 1},
        { letter = "L", clueIndex = 2, answerIndex = 1},
        { letter = "O", clueIndex = 2, answerIndex = 2}
      },
      {
        { letter = "A", clueIndex = 1, answerIndex = 2},
        { letter = "D", clueIndex = 2, answerIndex = 4},
        { letter = "U", clueIndex = 2, answerIndex = 3}
      },
      {
        { letter = "R", clueIndex = 1, answerIndex = 3},
        { letter = "C", clueIndex = 1, answerIndex = 4},
        { letter = "H", clueIndex = 1, answerIndex = 5}
      }
    },
    clues = {
      "Third month",
      "Noisy"
    }
  },
  {
    board = {
      {
        { letter = "S", clueIndex = 1, answerIndex = 1},
        { letter = "A", clueIndex = 1, answerIndex = 2},
        { letter = "L", clueIndex = 1, answerIndex = 3}
      },
      {
        { letter = "R", clueIndex = 2, answerIndex = 2},
        { letter = "C", clueIndex = 2, answerIndex = 1},
        { letter = "E", clueIndex = 1, answerIndex = 4}
      },
      {
        { letter = "O", clueIndex = 2, answerIndex = 3},
        { letter = "W", clueIndex = 2, answerIndex = 4},
        { letter = "N", clueIndex = 2, answerIndex = 5}
      }
    },
    clues = {
      "Discount",
      "Royal headgear"
    }
  },
  {
    board = {
      {
        { letter = "B", clueIndex = 1, answerIndex = 1},
        { letter = "E", clueIndex = 1, answerIndex = 2},
        { letter = "E", clueIndex = 1, answerIndex = 3}
      },
      {
        { letter = "E", clueIndex = 2, answerIndex = 4},
        { letter = "A", clueIndex = 3, answerIndex = 2},
        { letter = "N", clueIndex = 3, answerIndex = 3}
      },
      {
        { letter = "K", clueIndex = 2, answerIndex = 3},
        { letter = "M", clueIndex = 3, answerIndex = 1},
        { letter = "G", clueIndex = 3, answerIndex = 4}
      },
      {
        { letter = "A", clueIndex = 2, answerIndex = 2},
        { letter = "L", clueIndex = 2, answerIndex = 1},
        { letter = "O", clueIndex = 3, answerIndex = 5}
      }
    },
    clues = {
      "Pollinator",
      "Body of water",
      "Tropical fruit"
    }
  }
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RiverBendTutorialRounds.getTutorialRound(roundNumber)
  local concept = ROUNDS[roundNumber]
  return RiverBendModel.new(concept.board, concept.clues)
end

function RiverBendTutorialRounds.getCompletedTutorialClueData(roundNumber)
  if roundNumber == 1 then
    return {{1, 2}, {1, 3}, {2, 3}, {2, 2}}, 2
  else
    return nil, nil
  end
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------
