--- RiverBendWordStatus

class("RiverBendWordStatus")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

RiverBendWordStatus.INCORRECT = "incorrect"
RiverBendWordStatus.COMPLETE = "complete"

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Tests API
-- ----------------------------------------------------------------------------

function RiverBendWordStatus:isIncorrect()
  return self.statusCode == RiverBendWordStatus.INCORRECT
end

function RiverBendWordStatus:isComplete()
  return self.statusCode == RiverBendWordStatus.COMPLETE
end

function RiverBendWordStatus:getWord()
  return self.word
end

function RiverBendWordStatus:getClueIndex()
  return self.clueIndex
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function RiverBendWordStatus.new(statusCode, word, clueIndex)
  local self = {}
  Mixin.mix(self, RiverBendWordStatus)

  self.statusCode = statusCode
  self.word = word
  self.clueIndex = clueIndex

  return self
end
