--- default
-- @author Created by andrewcousins on November 07, 2024.
-- Test content validation entry point for Riverbend.

require("Bootstrap")
require("RiverBendValidator")
require("validators.SimpleParametersValidator")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local REQUIRED_PARAMETERS = {
  "correct_answer_points",
  "correct_needed"
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local validator = RiverBendValidator.new()
local parametersValidator = SimpleParametersValidator.new(REQUIRED_PARAMETERS)

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function validate(concept)
  validator:validate(concept)
  return validator:getPassed(), validator:getMessage()
end

function validateParameters(parameters)
  parametersValidator:validate(MOAIJsonParser.decode(parameters))
  return parametersValidator:getPassed(), parametersValidator:getMessage()
end
