--- RiverBendRoundManager
-- @author Created by andrewcousins on November 12, 2024.

class("RiverBendRoundManager")

require("RiverBendModel")
require("RiverBendTutorialRounds")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local TESTING_ROUNDS = {
  {
    '{"identifier": "riverbend_KUS-10651923", "filter_level": "medium_3,hard_1,hard_2", "board": [[{"letter": "H", "clueIndex": 4, "answerIndex": 2}, {"letter": "I", "clueIndex": 4, "answerIndex": 3}, {"letter": "T", "clueIndex": 4, "answerIndex": 6}, {"letter": "U", "clueIndex": 1, "answerIndex": 3}, {"letter": "N", "clueIndex": 1, "answerIndex": 4}], [{"letter": "T", "clueIndex": 4, "answerIndex": 1}, {"letter": "R", "clueIndex": 4, "answerIndex": 4}, {"letter": "S", "clueIndex": 4, "answerIndex": 5}, {"letter": "R", "clueIndex": 1, "answerIndex": 2}, {"letter": "C", "clueIndex": 1, "answerIndex": 5}], [{"letter": "O", "clueIndex": 5, "answerIndex": 4}, {"letter": "N", "clueIndex": 5, "answerIndex": 5}, {"letter": "S", "clueIndex": 2, "answerIndex": 1}, {"letter": "B", "clueIndex": 1, "answerIndex": 1}, {"letter": "H", "clueIndex": 1, "answerIndex": 6}], [{"letter": "R", "clueIndex": 5, "answerIndex": 3}, {"letter": "G", "clueIndex": 5, "answerIndex": 6}, {"letter": "C", "clueIndex": 2, "answerIndex": 2}, {"letter": "R", "clueIndex": 3, "answerIndex": 3}, {"letter": "I", "clueIndex": 3, "answerIndex": 4}], [{"letter": "H", "clueIndex": 5, "answerIndex": 2}, {"letter": "L", "clueIndex": 2, "answerIndex": 6}, {"letter": "R", "clueIndex": 2, "answerIndex": 3}, {"letter": "P", "clueIndex": 3, "answerIndex": 2}, {"letter": "N", "clueIndex": 3, "answerIndex": 5}], [{"letter": "T", "clueIndex": 5, "answerIndex": 1}, {"letter": "L", "clueIndex": 2, "answerIndex": 5}, {"letter": "O", "clueIndex": 2, "answerIndex": 4}, {"letter": "S", "clueIndex": 3, "answerIndex": 1}, {"letter": "G", "clueIndex": 3, "answerIndex": 6}]], "clues": ["Weekend breakfast", "Coiled document", "Mattress coil", "Parched feeling", "Large assembly"]}',
    '{"identifier": "riverbend_KUS-10651933", "filter_level": "medium_3,hard_1,hard_2", "board": [[{"letter": "E", "clueIndex": 2, "answerIndex": 2}, {"letter": "M", "clueIndex": 2, "answerIndex": 3}, {"letter": "O", "clueIndex": 3, "answerIndex": 1}, {"letter": "N", "clueIndex": 3, "answerIndex": 2}, {"letter": "L", "clueIndex": 3, "answerIndex": 3}], [{"letter": "M", "clueIndex": 2, "answerIndex": 1}, {"letter": "E", "clueIndex": 2, "answerIndex": 4}, {"letter": "E", "clueIndex": 3, "answerIndex": 6}, {"letter": "N", "clueIndex": 3, "answerIndex": 5}, {"letter": "I", "clueIndex": 3, "answerIndex": 4}], [{"letter": "U", "clueIndex": 5, "answerIndex": 1}, {"letter": "E", "clueIndex": 5, "answerIndex": 8}, {"letter": "E", "clueIndex": 4, "answerIndex": 7}, {"letter": "R", "clueIndex": 4, "answerIndex": 6}, {"letter": "A", "clueIndex": 4, "answerIndex": 5}], [{"letter": "S", "clueIndex": 5, "answerIndex": 2}, {"letter": "M", "clueIndex": 5, "answerIndex": 7}, {"letter": "B", "clueIndex": 1, "answerIndex": 3}, {"letter": "O", "clueIndex": 1, "answerIndex": 4}, {"letter": "W", "clueIndex": 4, "answerIndex": 4}], [{"letter": "E", "clueIndex": 5, "answerIndex": 3}, {"letter": "A", "clueIndex": 5, "answerIndex": 6}, {"letter": "N", "clueIndex": 1, "answerIndex": 2}, {"letter": "X", "clueIndex": 1, "answerIndex": 5}, {"letter": "Y", "clueIndex": 4, "answerIndex": 3}], [{"letter": "R", "clueIndex": 5, "answerIndex": 4}, {"letter": "N", "clueIndex": 5, "answerIndex": 5}, {"letter": "I", "clueIndex": 1, "answerIndex": 1}, {"letter": "S", "clueIndex": 4, "answerIndex": 1}, {"letter": "P", "clueIndex": 4, "answerIndex": 2}]], "clues": ["Place for new messages", "Viral internet item", "Logged in", "Invasive programs", "It\'s entered before a password"]}',
    '{"identifier": "riverbend_KUS-10651939", "filter_level": "medium_3,hard_1,hard_2", "board": [[{"letter": "S", "clueIndex": 4, "answerIndex": 1}, {"letter": "U", "clueIndex": 4, "answerIndex": 2}, {"letter": "T", "clueIndex": 5, "answerIndex": 1}, {"letter": "S", "clueIndex": 5, "answerIndex": 2}, {"letter": "I", "clueIndex": 5, "answerIndex": 7}], [{"letter": "C", "clueIndex": 2, "answerIndex": 1}, {"letter": "R", "clueIndex": 4, "answerIndex": 3}, {"letter": "F", "clueIndex": 4, "answerIndex": 4}, {"letter": "U", "clueIndex": 5, "answerIndex": 3}, {"letter": "M", "clueIndex": 5, "answerIndex": 6}], [{"letter": "U", "clueIndex": 2, "answerIndex": 2}, {"letter": "A", "clueIndex": 1, "answerIndex": 1}, {"letter": "R", "clueIndex": 1, "answerIndex": 2}, {"letter": "N", "clueIndex": 5, "answerIndex": 4}, {"letter": "A", "clueIndex": 5, "answerIndex": 5}], [{"letter": "R", "clueIndex": 2, "answerIndex": 3}, {"letter": "S", "clueIndex": 2, "answerIndex": 8}, {"letter": "C", "clueIndex": 1, "answerIndex": 3}, {"letter": "T", "clueIndex": 3, "answerIndex": 4}, {"letter": "P", "clueIndex": 3, "answerIndex": 3}], [{"letter": "R", "clueIndex": 2, "answerIndex": 4}, {"letter": "T", "clueIndex": 2, "answerIndex": 7}, {"letter": "T", "clueIndex": 1, "answerIndex": 4}, {"letter": "H", "clueIndex": 3, "answerIndex": 5}, {"letter": "E", "clueIndex": 3, "answerIndex": 2}], [{"letter": "E", "clueIndex": 2, "answerIndex": 5}, {"letter": "N", "clueIndex": 2, "answerIndex": 6}, {"letter": "I", "clueIndex": 1, "answerIndex": 5}, {"letter": "C", "clueIndex": 1, "answerIndex": 6}, {"letter": "D", "clueIndex": 3, "answerIndex": 1}]], "clues": ["Polar region", "Motions in the oceans", "Distance downward", "Breaking waves", "Destructive wave"]}',
    '{"identifier": "riverbend_KUS-10651936", "filter_level": "medium_3,hard_1,hard_2", "board": [[{"letter": "R", "clueIndex": 5, "answerIndex": 1}, {"letter": "I", "clueIndex": 5, "answerIndex": 2}, {"letter": "S", "clueIndex": 5, "answerIndex": 3}, {"letter": "O", "clueIndex": 5, "answerIndex": 4}, {"letter": "T", "clueIndex": 5, "answerIndex": 5}], [{"letter": "R", "clueIndex": 1, "answerIndex": 1}, {"letter": "A", "clueIndex": 1, "answerIndex": 2}, {"letter": "D", "clueIndex": 1, "answerIndex": 3}, {"letter": "O", "clueIndex": 5, "answerIndex": 7}, {"letter": "T", "clueIndex": 5, "answerIndex": 6}], [{"letter": "R", "clueIndex": 2, "answerIndex": 1}, {"letter": "A", "clueIndex": 2, "answerIndex": 2}, {"letter": "A", "clueIndex": 1, "answerIndex": 4}, {"letter": "R", "clueIndex": 1, "answerIndex": 5}, {"letter": "R", "clueIndex": 4, "answerIndex": 1}], [{"letter": "R", "clueIndex": 3, "answerIndex": 1}, {"letter": "D", "clueIndex": 2, "answerIndex": 3}, {"letter": "I", "clueIndex": 2, "answerIndex": 4}, {"letter": "O", "clueIndex": 2, "answerIndex": 5}, {"letter": "E", "clueIndex": 4, "answerIndex": 2}], [{"letter": "A", "clueIndex": 3, "answerIndex": 2}, {"letter": "Z", "clueIndex": 3, "answerIndex": 3}, {"letter": "T", "clueIndex": 4, "answerIndex": 5}, {"letter": "U", "clueIndex": 4, "answerIndex": 4}, {"letter": "B", "clueIndex": 4, "answerIndex": 3}], [{"letter": "R", "clueIndex": 3, "answerIndex": 5}, {"letter": "O", "clueIndex": 3, "answerIndex": 4}, {"letter": "T", "clueIndex": 4, "answerIndex": 6}, {"letter": "A", "clueIndex": 4, "answerIndex": 7}, {"letter": "L", "clueIndex": 4, "answerIndex": 8}]], "clues": ["Pilot\'s instrument", "AM/FM appliance", "Mustache remover", "Presentation of an opposing view", "Rice dish, in Rome"]}'
  },
  {
    '{"identifier": "riverbend_KUS-10652004", "filter_level": "hard_3,very_hard_1", "board": [[{"letter": "I", "clueIndex": 3, "answerIndex": 4}, {"letter": "A", "clueIndex": 3, "answerIndex": 5}, {"letter": "A", "clueIndex": 2, "answerIndex": 1}, {"letter": "A", "clueIndex": 4, "answerIndex": 1}, {"letter": "T", "clueIndex": 5, "answerIndex": 3}, {"letter": "I", "clueIndex": 5, "answerIndex": 4}], [{"letter": "R", "clueIndex": 3, "answerIndex": 3}, {"letter": "L", "clueIndex": 3, "answerIndex": 6}, {"letter": "C", "clueIndex": 2, "answerIndex": 2}, {"letter": "N", "clueIndex": 4, "answerIndex": 2}, {"letter": "R", "clueIndex": 5, "answerIndex": 2}, {"letter": "S", "clueIndex": 5, "answerIndex": 5}], [{"letter": "E", "clueIndex": 3, "answerIndex": 2}, {"letter": "E", "clueIndex": 2, "answerIndex": 6}, {"letter": "T", "clueIndex": 2, "answerIndex": 3}, {"letter": "T", "clueIndex": 4, "answerIndex": 3}, {"letter": "A", "clueIndex": 5, "answerIndex": 1}, {"letter": "T", "clueIndex": 5, "answerIndex": 6}], [{"letter": "A", "clueIndex": 3, "answerIndex": 1}, {"letter": "V", "clueIndex": 2, "answerIndex": 5}, {"letter": "I", "clueIndex": 2, "answerIndex": 4}, {"letter": "I", "clueIndex": 4, "answerIndex": 4}, {"letter": "E", "clueIndex": 4, "answerIndex": 7}, {"letter": "I", "clueIndex": 5, "answerIndex": 7}], [{"letter": "B", "clueIndex": 6, "answerIndex": 7}, {"letter": "A", "clueIndex": 6, "answerIndex": 6}, {"letter": "A", "clueIndex": 6, "answerIndex": 1}, {"letter": "Q", "clueIndex": 4, "answerIndex": 5}, {"letter": "U", "clueIndex": 4, "answerIndex": 6}, {"letter": "C", "clueIndex": 5, "answerIndex": 8}], [{"letter": "L", "clueIndex": 6, "answerIndex": 8}, {"letter": "L", "clueIndex": 6, "answerIndex": 5}, {"letter": "V", "clueIndex": 6, "answerIndex": 2}, {"letter": "B", "clueIndex": 1, "answerIndex": 2}, {"letter": "R", "clueIndex": 1, "answerIndex": 3}, {"letter": "T", "clueIndex": 1, "answerIndex": 6}], [{"letter": "E", "clueIndex": 6, "answerIndex": 9}, {"letter": "I", "clueIndex": 6, "answerIndex": 4}, {"letter": "A", "clueIndex": 6, "answerIndex": 3}, {"letter": "A", "clueIndex": 1, "answerIndex": 1}, {"letter": "U", "clueIndex": 1, "answerIndex": 4}, {"letter": "P", "clueIndex": 1, "answerIndex": 5}]], "clues": ["Ending suddenly", "Apt to erupt", "Up in the sky", "Kind of furniture", "Having creative flair", "Not booked"]}',
    '{"identifier": "riverbend_KUS-10652032", "filter_level": "hard_3,very_hard_1", "board": [[{"letter": "R", "clueIndex": 2, "answerIndex": 2}, {"letter": "O", "clueIndex": 2, "answerIndex": 3}, {"letter": "A", "clueIndex": 1, "answerIndex": 1}, {"letter": "N", "clueIndex": 1, "answerIndex": 2}, {"letter": "C", "clueIndex": 1, "answerIndex": 3}, {"letter": "H", "clueIndex": 1, "answerIndex": 4}], [{"letter": "E", "clueIndex": 2, "answerIndex": 1}, {"letter": "S", "clueIndex": 2, "answerIndex": 4}, {"letter": "T", "clueIndex": 6, "answerIndex": 1}, {"letter": "U", "clueIndex": 6, "answerIndex": 2}, {"letter": "R", "clueIndex": 1, "answerIndex": 6}, {"letter": "O", "clueIndex": 1, "answerIndex": 5}], [{"letter": "L", "clueIndex": 4, "answerIndex": 1}, {"letter": "I", "clueIndex": 2, "answerIndex": 5}, {"letter": "F", "clueIndex": 3, "answerIndex": 1}, {"letter": "N", "clueIndex": 6, "answerIndex": 3}, {"letter": "N", "clueIndex": 6, "answerIndex": 4}, {"letter": "E", "clueIndex": 6, "answerIndex": 5}], [{"letter": "A", "clueIndex": 4, "answerIndex": 2}, {"letter": "O", "clueIndex": 2, "answerIndex": 6}, {"letter": "I", "clueIndex": 3, "answerIndex": 2}, {"letter": "S", "clueIndex": 3, "answerIndex": 3}, {"letter": "S", "clueIndex": 3, "answerIndex": 4}, {"letter": "L", "clueIndex": 6, "answerIndex": 6}], [{"letter": "N", "clueIndex": 4, "answerIndex": 3}, {"letter": "N", "clueIndex": 2, "answerIndex": 7}, {"letter": "T", "clueIndex": 5, "answerIndex": 6}, {"letter": "O", "clueIndex": 5, "answerIndex": 7}, {"letter": "U", "clueIndex": 3, "answerIndex": 5}, {"letter": "R", "clueIndex": 3, "answerIndex": 6}], [{"letter": "Y", "clueIndex": 4, "answerIndex": 4}, {"letter": "A", "clueIndex": 4, "answerIndex": 5}, {"letter": "S", "clueIndex": 5, "answerIndex": 5}, {"letter": "N", "clueIndex": 5, "answerIndex": 8}, {"letter": "E", "clueIndex": 5, "answerIndex": 9}, {"letter": "E", "clueIndex": 3, "answerIndex": 7}], [{"letter": "D", "clueIndex": 4, "answerIndex": 7}, {"letter": "R", "clueIndex": 4, "answerIndex": 6}, {"letter": "E", "clueIndex": 5, "answerIndex": 4}, {"letter": "M", "clueIndex": 5, "answerIndex": 3}, {"letter": "I", "clueIndex": 5, "answerIndex": 2}, {"letter": "L", "clueIndex": 5, "answerIndex": 1}]], "clues": ["Fasten securely", "Wearing away", "Long, narrow crack", "Whistle holder", "Sedimentary rock", "Underground passage"]}',
    '{"identifier": "riverbend_KUS-10651964", "filter_level": "medium_3,hard_1,hard_2", "board": [[{"letter": "U", "clueIndex": 2, "answerIndex": 3}, {"letter": "R", "clueIndex": 2, "answerIndex": 2}, {"letter": "C", "clueIndex": 2, "answerIndex": 1}, {"letter": "N", "clueIndex": 6, "answerIndex": 1}, {"letter": "E", "clueIndex": 6, "answerIndex": 2}], [{"letter": "M", "clueIndex": 2, "answerIndex": 4}, {"letter": "B", "clueIndex": 2, "answerIndex": 5}, {"letter": "I", "clueIndex": 4, "answerIndex": 3}, {"letter": "R", "clueIndex": 4, "answerIndex": 4}, {"letter": "E", "clueIndex": 6, "answerIndex": 3}], [{"letter": "L", "clueIndex": 5, "answerIndex": 4}, {"letter": "L", "clueIndex": 5, "answerIndex": 5}, {"letter": "A", "clueIndex": 4, "answerIndex": 2}, {"letter": "H", "clueIndex": 4, "answerIndex": 1}, {"letter": "D", "clueIndex": 6, "answerIndex": 4}], [{"letter": "I", "clueIndex": 5, "answerIndex": 3}, {"letter": "R", "clueIndex": 5, "answerIndex": 2}, {"letter": "K", "clueIndex": 5, "answerIndex": 1}, {"letter": "E", "clueIndex": 6, "answerIndex": 6}, {"letter": "L", "clueIndex": 6, "answerIndex": 5}], [{"letter": "B", "clueIndex": 1, "answerIndex": 1}, {"letter": "O", "clueIndex": 1, "answerIndex": 2}, {"letter": "N", "clueIndex": 1, "answerIndex": 3}, {"letter": "N", "clueIndex": 3, "answerIndex": 4}, {"letter": "W", "clueIndex": 3, "answerIndex": 3}], [{"letter": "I", "clueIndex": 1, "answerIndex": 6}, {"letter": "A", "clueIndex": 1, "answerIndex": 5}, {"letter": "S", "clueIndex": 1, "answerIndex": 4}, {"letter": "F", "clueIndex": 3, "answerIndex": 1}, {"letter": "A", "clueIndex": 3, "answerIndex": 2}]], "clues": ["Dwarfed tree", "Speck of bread", "Little deer", "Barber\'s concern", "Crustaceans eaten by whales", "Haystack hider"]}',
    '{"identifier": "riverbend_KUS-10652018", "filter_level": "hard_3,very_hard_1", "board": [[{"letter": "C", "clueIndex": 4, "answerIndex": 1}, {"letter": "A", "clueIndex": 4, "answerIndex": 2}, {"letter": "A", "clueIndex": 1, "answerIndex": 1}, {"letter": "N", "clueIndex": 1, "answerIndex": 2}, {"letter": "T", "clueIndex": 1, "answerIndex": 3}, {"letter": "R", "clueIndex": 1, "answerIndex": 8}], [{"letter": "D", "clueIndex": 6, "answerIndex": 1}, {"letter": "N", "clueIndex": 4, "answerIndex": 3}, {"letter": "L", "clueIndex": 3, "answerIndex": 6}, {"letter": "I", "clueIndex": 3, "answerIndex": 5}, {"letter": "E", "clueIndex": 1, "answerIndex": 4}, {"letter": "E", "clueIndex": 1, "answerIndex": 7}], [{"letter": "O", "clueIndex": 6, "answerIndex": 2}, {"letter": "O", "clueIndex": 4, "answerIndex": 4}, {"letter": "E", "clueIndex": 4, "answerIndex": 5}, {"letter": "Z", "clueIndex": 3, "answerIndex": 4}, {"letter": "A", "clueIndex": 1, "answerIndex": 5}, {"letter": "T", "clueIndex": 1, "answerIndex": 6}], [{"letter": "L", "clueIndex": 6, "answerIndex": 3}, {"letter": "B", "clueIndex": 3, "answerIndex": 1}, {"letter": "R", "clueIndex": 3, "answerIndex": 2}, {"letter": "A", "clueIndex": 3, "answerIndex": 3}, {"letter": "A", "clueIndex": 2, "answerIndex": 5}, {"letter": "C", "clueIndex": 2, "answerIndex": 4}], [{"letter": "P", "clueIndex": 6, "answerIndex": 4}, {"letter": "N", "clueIndex": 6, "answerIndex": 7}, {"letter": "M", "clueIndex": 5, "answerIndex": 5}, {"letter": "P", "clueIndex": 5, "answerIndex": 6}, {"letter": "D", "clueIndex": 2, "answerIndex": 6}, {"letter": "O", "clueIndex": 2, "answerIndex": 3}], [{"letter": "H", "clueIndex": 6, "answerIndex": 5}, {"letter": "I", "clueIndex": 6, "answerIndex": 6}, {"letter": "O", "clueIndex": 5, "answerIndex": 4}, {"letter": "O", "clueIndex": 5, "answerIndex": 7}, {"letter": "O", "clueIndex": 2, "answerIndex": 7}, {"letter": "V", "clueIndex": 2, "answerIndex": 2}], [{"letter": "D", "clueIndex": 5, "answerIndex": 1}, {"letter": "E", "clueIndex": 5, "answerIndex": 2}, {"letter": "C", "clueIndex": 5, "answerIndex": 3}, {"letter": "S", "clueIndex": 5, "answerIndex": 8}, {"letter": "E", "clueIndex": 5, "answerIndex": 9}, {"letter": "A", "clueIndex": 2, "answerIndex": 1}]], "clues": ["Sticky-tongued animal", "Guacamole base", "Largest country in South America", "Kayak alternative", "Break down chemically", "Member of a pod"]}'
  },
  {
    '{"identifier": "riverbend_KUS-10652008", "filter_level": "hard_3,very_hard_1", "board": [[{"letter": "H", "clueIndex": 6, "answerIndex": 2}, {"letter": "E", "clueIndex": 6, "answerIndex": 3}, {"letter": "D", "clueIndex": 3, "answerIndex": 1}, {"letter": "R", "clueIndex": 3, "answerIndex": 4}, {"letter": "A", "clueIndex": 1, "answerIndex": 6}, {"letter": "G", "clueIndex": 1, "answerIndex": 5}], [{"letter": "S", "clueIndex": 6, "answerIndex": 1}, {"letter": "E", "clueIndex": 6, "answerIndex": 4}, {"letter": "E", "clueIndex": 3, "answerIndex": 2}, {"letter": "E", "clueIndex": 3, "answerIndex": 3}, {"letter": "T", "clueIndex": 1, "answerIndex": 7}, {"letter": "I", "clueIndex": 1, "answerIndex": 4}], [{"letter": "L", "clueIndex": 5, "answerIndex": 1}, {"letter": "P", "clueIndex": 6, "answerIndex": 5}, {"letter": "S", "clueIndex": 7, "answerIndex": 1}, {"letter": "N", "clueIndex": 7, "answerIndex": 2}, {"letter": "O", "clueIndex": 1, "answerIndex": 8}, {"letter": "L", "clueIndex": 1, "answerIndex": 3}], [{"letter": "I", "clueIndex": 5, "answerIndex": 2}, {"letter": "O", "clueIndex": 5, "answerIndex": 3}, {"letter": "E", "clueIndex": 2, "answerIndex": 8}, {"letter": "A", "clueIndex": 7, "answerIndex": 3}, {"letter": "R", "clueIndex": 1, "answerIndex": 9}, {"letter": "L", "clueIndex": 1, "answerIndex": 2}], [{"letter": "A", "clueIndex": 2, "answerIndex": 1}, {"letter": "N", "clueIndex": 5, "answerIndex": 4}, {"letter": "P", "clueIndex": 2, "answerIndex": 7}, {"letter": "K", "clueIndex": 7, "answerIndex": 4}, {"letter": "E", "clueIndex": 7, "answerIndex": 5}, {"letter": "A", "clueIndex": 1, "answerIndex": 1}], [{"letter": "N", "clueIndex": 2, "answerIndex": 2}, {"letter": "L", "clueIndex": 2, "answerIndex": 5}, {"letter": "O", "clueIndex": 2, "answerIndex": 6}, {"letter": "G", "clueIndex": 4, "answerIndex": 1}, {"letter": "O", "clueIndex": 4, "answerIndex": 2}, {"letter": "R", "clueIndex": 4, "answerIndex": 3}], [{"letter": "T", "clueIndex": 2, "answerIndex": 3}, {"letter": "E", "clueIndex": 2, "answerIndex": 4}, {"letter": "A", "clueIndex": 4, "answerIndex": 7}, {"letter": "L", "clueIndex": 4, "answerIndex": 6}, {"letter": "L", "clueIndex": 4, "answerIndex": 5}, {"letter": "I", "clueIndex": 4, "answerIndex": 4}]], "clues": ["Crocodile\'s cousin", "Serengeti grazer", "Bambi and friends", "Greatest of the apes", "King of the beasts", "What insomniacs count", "Limbless reptile"]}',
    '{"identifier": "riverbend_KUS-10638907", "filter_level": "expert_3", "board": [[{"letter": "N", "clueIndex": 4, "answerIndex": 2}, {"letter": "E", "clueIndex": 4, "answerIndex": 3}, {"letter": "U", "clueIndex": 6, "answerIndex": 1}, {"letter": "T", "clueIndex": 1, "answerIndex": 7}, {"letter": "U", "clueIndex": 1, "answerIndex": 8}, {"letter": "U", "clueIndex": 7, "answerIndex": 1}, {"letter": "S", "clueIndex": 7, "answerIndex": 2}, {"letter": "E", "clueIndex": 7, "answerIndex": 3}], [{"letter": "U", "clueIndex": 4, "answerIndex": 1}, {"letter": "M", "clueIndex": 4, "answerIndex": 4}, {"letter": "N", "clueIndex": 6, "answerIndex": 2}, {"letter": "A", "clueIndex": 1, "answerIndex": 6}, {"letter": "M", "clueIndex": 1, "answerIndex": 9}, {"letter": "L", "clueIndex": 7, "answerIndex": 6}, {"letter": "U", "clueIndex": 7, "answerIndex": 5}, {"letter": "F", "clueIndex": 7, "answerIndex": 4}], [{"letter": "U", "clueIndex": 2, "answerIndex": 1}, {"letter": "P", "clueIndex": 4, "answerIndex": 5}, {"letter": "W", "clueIndex": 6, "answerIndex": 3}, {"letter": "M", "clueIndex": 1, "answerIndex": 5}, {"letter": "E", "clueIndex": 3, "answerIndex": 12}, {"letter": "L", "clueIndex": 3, "answerIndex": 11}, {"letter": "U", "clueIndex": 5, "answerIndex": 1}, {"letter": "N", "clueIndex": 5, "answerIndex": 2}], [{"letter": "L", "clueIndex": 2, "answerIndex": 2}, {"letter": "L", "clueIndex": 4, "answerIndex": 6}, {"letter": "A", "clueIndex": 6, "answerIndex": 4}, {"letter": "I", "clueIndex": 1, "answerIndex": 4}, {"letter": "T", "clueIndex": 1, "answerIndex": 3}, {"letter": "B", "clueIndex": 3, "answerIndex": 10}, {"letter": "E", "clueIndex": 5, "answerIndex": 8}, {"letter": "U", "clueIndex": 5, "answerIndex": 3}], [{"letter": "T", "clueIndex": 2, "answerIndex": 3}, {"letter": "O", "clueIndex": 4, "answerIndex": 7}, {"letter": "N", "clueIndex": 6, "answerIndex": 5}, {"letter": "D", "clueIndex": 6, "answerIndex": 8}, {"letter": "L", "clueIndex": 1, "answerIndex": 2}, {"letter": "A", "clueIndex": 3, "answerIndex": 9}, {"letter": "L", "clueIndex": 5, "answerIndex": 7}, {"letter": "S", "clueIndex": 5, "answerIndex": 4}], [{"letter": "R", "clueIndex": 2, "answerIndex": 4}, {"letter": "Y", "clueIndex": 4, "answerIndex": 8}, {"letter": "T", "clueIndex": 6, "answerIndex": 6}, {"letter": "E", "clueIndex": 6, "answerIndex": 7}, {"letter": "U", "clueIndex": 1, "answerIndex": 1}, {"letter": "V", "clueIndex": 3, "answerIndex": 8}, {"letter": "B", "clueIndex": 5, "answerIndex": 6}, {"letter": "A", "clueIndex": 5, "answerIndex": 5}], [{"letter": "A", "clueIndex": 2, "answerIndex": 5}, {"letter": "E", "clueIndex": 4, "answerIndex": 9}, {"letter": "D", "clueIndex": 4, "answerIndex": 10}, {"letter": "E", "clueIndex": 2, "answerIndex": 10}, {"letter": "T", "clueIndex": 2, "answerIndex": 11}, {"letter": "E", "clueIndex": 3, "answerIndex": 7}, {"letter": "I", "clueIndex": 3, "answerIndex": 6}, {"letter": "L", "clueIndex": 3, "answerIndex": 5}], [{"letter": "V", "clueIndex": 2, "answerIndex": 6}, {"letter": "I", "clueIndex": 2, "answerIndex": 7}, {"letter": "O", "clueIndex": 2, "answerIndex": 8}, {"letter": "L", "clueIndex": 2, "answerIndex": 9}, {"letter": "U", "clueIndex": 3, "answerIndex": 1}, {"letter": "N", "clueIndex": 3, "answerIndex": 2}, {"letter": "B", "clueIndex": 3, "answerIndex": 3}, {"letter": "E", "clueIndex": 3, "answerIndex": 4}]], "clues": ["Final offer", "Nonvisible light", "Improbable", "Without a job", "Broken beyond repair", "No longer desired", "Not just decorative"]}',
    '{"identifier": "riverbend_KUS-10651917", "filter_level": "medium_3,hard_1,hard_2", "board": [[{"letter": "L", "clueIndex": 6, "answerIndex": 4}, {"letter": "E", "clueIndex": 6, "answerIndex": 3}, {"letter": "O", "clueIndex": 3, "answerIndex": 4}, {"letter": "B", "clueIndex": 3, "answerIndex": 3}, {"letter": "L", "clueIndex": 3, "answerIndex": 2}], [{"letter": "H", "clueIndex": 6, "answerIndex": 1}, {"letter": "E", "clueIndex": 6, "answerIndex": 2}, {"letter": "W", "clueIndex": 3, "answerIndex": 5}, {"letter": "N", "clueIndex": 2, "answerIndex": 4}, {"letter": "E", "clueIndex": 3, "answerIndex": 1}], [{"letter": "D", "clueIndex": 5, "answerIndex": 4}, {"letter": "N", "clueIndex": 5, "answerIndex": 3}, {"letter": "H", "clueIndex": 2, "answerIndex": 2}, {"letter": "I", "clueIndex": 2, "answerIndex": 3}, {"letter": "E", "clueIndex": 1, "answerIndex": 4}], [{"letter": "H", "clueIndex": 5, "answerIndex": 1}, {"letter": "A", "clueIndex": 5, "answerIndex": 2}, {"letter": "C", "clueIndex": 2, "answerIndex": 1}, {"letter": "O", "clueIndex": 1, "answerIndex": 2}, {"letter": "N", "clueIndex": 1, "answerIndex": 3}], [{"letter": "T", "clueIndex": 4, "answerIndex": 4}, {"letter": "E", "clueIndex": 4, "answerIndex": 3}, {"letter": "W", "clueIndex": 7, "answerIndex": 1}, {"letter": "B", "clueIndex": 1, "answerIndex": 1}, {"letter": "T", "clueIndex": 7, "answerIndex": 5}], [{"letter": "F", "clueIndex": 4, "answerIndex": 1}, {"letter": "E", "clueIndex": 4, "answerIndex": 2}, {"letter": "A", "clueIndex": 7, "answerIndex": 2}, {"letter": "I", "clueIndex": 7, "answerIndex": 3}, {"letter": "S", "clueIndex": 7, "answerIndex": 4}]], "clues": ["Canine treat", "Goatee locale", "Word with pad or grease", "Pedal pushers", "Arm ending", "Achilles\'s weak spot", "Hula hoop site"]}',
    '{"identifier": "riverbend_KUS-10652035", "filter_level": "hard_3,very_hard_1", "board": [[{"letter": "L", "clueIndex": 3, "answerIndex": 6}, {"letter": "F", "clueIndex": 3, "answerIndex": 5}, {"letter": "P", "clueIndex": 3, "answerIndex": 4}, {"letter": "I", "clueIndex": 3, "answerIndex": 3}, {"letter": "L", "clueIndex": 3, "answerIndex": 2}, {"letter": "F", "clueIndex": 3, "answerIndex": 1}], [{"letter": "O", "clueIndex": 3, "answerIndex": 7}, {"letter": "P", "clueIndex": 3, "answerIndex": 8}, {"letter": "S", "clueIndex": 3, "answerIndex": 9}, {"letter": "L", "clueIndex": 5, "answerIndex": 1}, {"letter": "S", "clueIndex": 5, "answerIndex": 4}, {"letter": "S", "clueIndex": 1, "answerIndex": 7}], [{"letter": "W", "clueIndex": 7, "answerIndex": 1}, {"letter": "I", "clueIndex": 7, "answerIndex": 2}, {"letter": "N", "clueIndex": 7, "answerIndex": 3}, {"letter": "E", "clueIndex": 5, "answerIndex": 2}, {"letter": "G", "clueIndex": 5, "answerIndex": 3}, {"letter": "R", "clueIndex": 1, "answerIndex": 6}], [{"letter": "G", "clueIndex": 4, "answerIndex": 1}, {"letter": "S", "clueIndex": 7, "answerIndex": 5}, {"letter": "G", "clueIndex": 7, "answerIndex": 4}, {"letter": "A", "clueIndex": 1, "answerIndex": 1}, {"letter": "N", "clueIndex": 1, "answerIndex": 2}, {"letter": "E", "clueIndex": 1, "answerIndex": 5}], [{"letter": "L", "clueIndex": 4, "answerIndex": 2}, {"letter": "S", "clueIndex": 2, "answerIndex": 6}, {"letter": "K", "clueIndex": 2, "answerIndex": 5}, {"letter": "E", "clueIndex": 2, "answerIndex": 4}, {"letter": "T", "clueIndex": 1, "answerIndex": 3}, {"letter": "L", "clueIndex": 1, "answerIndex": 4}], [{"letter": "O", "clueIndex": 4, "answerIndex": 3}, {"letter": "S", "clueIndex": 4, "answerIndex": 6}, {"letter": "H", "clueIndex": 2, "answerIndex": 2}, {"letter": "E", "clueIndex": 2, "answerIndex": 3}, {"letter": "I", "clueIndex": 6, "answerIndex": 3}, {"letter": "N", "clueIndex": 6, "answerIndex": 4}], [{"letter": "V", "clueIndex": 4, "answerIndex": 4}, {"letter": "E", "clueIndex": 4, "answerIndex": 5}, {"letter": "C", "clueIndex": 2, "answerIndex": 1}, {"letter": "T", "clueIndex": 6, "answerIndex": 1}, {"letter": "W", "clueIndex": 6, "answerIndex": 2}, {"letter": "S", "clueIndex": 6, "answerIndex": 5}]], "clues": ["Reindeer features", "Dimple sites", "Cheap sandals", "Winter warmers", "You stand on them often", "Genetic duplicates", "Butterfly\'s pair"]}'
  }
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getRoundFromDatabase(roundNumber)
  local puzzleSetupString = TableUtils.getRandomElement(TESTING_ROUNDS[roundNumber])
  local concept = MOAIJsonParser.decode(puzzleSetupString)
  local board = concept.board
  local clues = concept.clues

  return RiverBendModel.new(board, clues)
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RiverBendRoundManager.getRound(roundNumber)
  if GameSession.hasNeverWon() then
    return RiverBendTutorialRounds.getTutorialRound(roundNumber)
  else
    return getRoundFromDatabase(roundNumber)
  end
end
